<script>
  import Button, { Group, GroupItem, Label, Icon } from "@smui/button";
  import Version from "./Version.svelte";

  // Build Variables
  const baseDetails = {
    client_id: "CLIENT_ID",
    redirect_uri: "DOMAIN",
    response_type: "code",
    scope: "SCOPE"
  };
  const botDetails = {
    permissions: "BOT_PERMISSIONS",
    scope: baseDetails.scope + " bot"
  };
  const generateLink = params =>
    "https://discord.com/api/oauth2/authorize?" +
    Object.entries(params)
      .map(([param, val]) => `${param}=${encodeURIComponent(val)}`)
      .join("&");
  // DISCORD URLS
  const manageLink = generateLink(baseDetails);
  const inviteLink = generateLink({ ...baseDetails, ...botDetails });
</script>

<style type="text/scss">
  @font-face {
    font-family: "Trade Gothic LT Bold";
    src: url("../resources/TradeGothicLTBold.ttf") format("truetype");
  }

  div.top {
    display: flex;
    flex-direction: row;
    justify-content: center;
    margin: 10vh auto 0;
  }

  h1.tars {
    color: #bf7e1a;
    text-transform: uppercase;
    font-size: 12em;
    padding: 20px 50px;
    font-weight: 100;
    font-family: "Trade Gothic LT Bold";
    margin: 0;
    width: fit-content;
    text-align: center;
    border-radius: 1vh;
  }

  h1.metal {
    text-shadow: hsla(0, 0%, 40%, 0.5) 0 -1px 0,
      hsla(0, 0%, 100%, 0.6) 0 2px 1px;
    background-image: url("../resources/metal.jpg");
    background-color: rgba(0, 0, 0, 0.4);
    background-blend-mode: multiply;
  }
  
  div.discord-actions {
    display: flex;
    flex-direction: row;
    justify-content: center;
    margin: 1vh;
  }

  .test {
    margin: 1vw;
  }
</style>

<section>
  <div class="top">
    <Version>
      <h1 class="tars metal">TARS</h1>
    </Version>
  </div>
  <div class="discord-actions">
    <div class="test">
      <Button variant="raised" href={inviteLink}>
        <Label>Invite To Server</Label>
      </Button>
    </div>
    <div class="test">
      <Button variant="outlined" href={manageLink}>
        <Label>Manage Sounds</Label>
      </Button>
    </div>
  </div>
</section>
